package svc

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/lib/push"
	"applet/app/md"
	"applet/app/utils"
	"fmt"
	"time"
	"xorm.io/xorm"
)

func OrderReturnMoneyRelateInsert(eg *xorm.Engine, oid int64, pvd string, createTime int, returnMoneyOne map[string]interface{}, newOrd *model.OrdList, masterId string, isDelete bool) {
	returnRelate, ok := returnMoneyOne["extend_commission"].([]interface{})
	if returnRelate == nil || ok == false {
		return
	}
	if isDelete {
		fmt.Println("=====================写入明细2", newOrd.PvdOid)
		if newOrd.ReturnMoneySettleAt > 0 {
			db.OrderRelateDeleteByOidbylevel(eg, oid, pvd)
		} else {
			db.OrderRelateDeleteByOid(eg, oid, pvd)
		}
	}
	var data []*model.OrdListRelate
	uid := 0
	for _, v := range returnRelate {
		v1 := v.(map[string]interface{})
		if int(utils.AnyToInt64(v1["diff"])) == 0 {
			uid = int(utils.AnyToInt64(v1["uid"]))
		}
		var tmp = &model.OrdListRelate{
			Oid:         oid,
			Uid:         int(utils.AnyToInt64(v1["uid"])),
			Amount:      utils.AnyToFloat64(v1["commission"]),
			ReturnMoney: utils.AnyToFloat64(v1["return_money"]),
			Pvd:         pvd,
			CreateAt:    createTime,
			Level:       int(utils.AnyToInt64(v1["diff"])),
		}
		if tmp.Level == 0 && newOrd.ReturnMoneySettleAt > 0 && isDelete {
			continue
		}
		data = append(data, tmp)
	}
	//后写入
	err := db.DbInsertBatch(eg, data)
	if err != nil {
		return
	}
	//后台推送
	appName := db.SysCfgGetWithDb(eg, masterId, "app_name_cn")
	if uid == 0 {
		return
	}
	users, err := db.UserFindByID(eg, uid)
	if users == nil || err != nil {
		return
	}
	if newOrd.IsSendMsg == 1 { //不发送
		return
	}
	for _, v := range data {
		if v.Amount == 0 {
			v.Amount = v.ReturnMoney
		}
		var args md.PushParams
		args.AppName = appName
		args.Nickname = users.Nickname
		args.RegNickname = users.Nickname
		args.RegPhone = users.Phone
		args.Payment = utils.Float64ToStr(newOrd.PaidPrice)
		args.OrderNickname = users.Nickname
		args.OrderNo = newOrd.PvdOid
		args.OrderTime = time.Unix(int64(newOrd.CreateAt), 0).Format("2006-1-02 15:04:05")
		args.Fcommission = utils.Float64ToStr(v.Amount)
		args.Money = utils.Float64ToStr(v.Amount)
		args.Uid = v.Uid
		args.MasterId = masterId
		args.PushType = "order_team"
		if v.Level == 0 && newOrd.OrderType == 0 {
			args.PushType = "order_self"
		}
		if v.Level == 0 && newOrd.OrderType == 1 {
			args.PushType = "order_share"
		}
		if v.Level == 0 || v.Amount > 0 {
			args.Times = time.Now().Format("2006-01-02")
			push.CommAddPush(eg, args)
		}
	}
	newOrd.IsSendMsg = 1
	_, _ = db.OrdUpdateOne(eg, newOrd)

}
func PlayLetOrderReturnMoneyRelateInsert(eg *xorm.Engine, oid int64, pvd string, createTime int, returnMoneyOne map[string]interface{}, newOrd *model.OrdList, masterId string, isDelete bool) {
	returnRelate, ok := returnMoneyOne["extend_commission"].([]interface{})
	if returnRelate == nil || ok == false {
		return
	}
	if isDelete {
		fmt.Println("=====================写入明细2", newOrd.PvdOid)
		if newOrd.ReturnMoneySettleAt > 0 {
			db.OrderRelateDeleteByOidbylevel(eg, oid, pvd)
		} else {
			db.OrderRelateDeleteByOid(eg, oid, pvd)
		}
	}
	var data []*model.OrdListRelate
	for _, v := range returnRelate {
		v1 := v.(map[string]interface{})
		var tmp = &model.OrdListRelate{
			Oid:         oid,
			Uid:         int(utils.AnyToInt64(v1["uid"])),
			Amount:      utils.AnyToFloat64(v1["commission"]),
			ReturnMoney: utils.AnyToFloat64(v1["return_money"]),
			Pvd:         pvd,
			CreateAt:    createTime,
			Level:       int(utils.AnyToInt64(v1["diff"])),
		}
		if tmp.Level == 0 && newOrd.ReturnMoneySettleAt > 0 && isDelete {
			continue
		}
		data = append(data, tmp)
	}
	//后写入
	err := db.DbInsertBatch(eg, data)
	if err != nil {
		return
	}

}
